<template>
  <Dialog :title="dialogTitle" v-model="dialogVisible">
    <el-form
      ref="formRef"
      :model="formData"
      :rules="formRules"
      label-width="100px"
      v-loading="formLoading"
    >
      <el-form-item label="用户id" prop="bqrUserId">
        <el-input v-model="formData.bqrUserId" placeholder="请输入用户id" />
      </el-form-item>
      <el-form-item label="问卷id" prop="bqrQuestionnaireId">
        <el-input v-model="formData.bqrQuestionnaireId" placeholder="请输入问卷id" />
      </el-form-item>
      <el-form-item label="答卷状态" prop="bqrStatus">
        <el-radio-group v-model="formData.bqrStatus">
          <el-radio
            v-for="dict in getStrDictOptions(DICT_TYPE.BJDX_QUESTIONNAIRE_STATUS)"
            :key="dict.value"
            :label="dict.value"
          >
            {{ dict.label }}
          </el-radio>
        </el-radio-group>
      </el-form-item>
      <el-form-item label="试卷得分" prop="bqrSorce">
        <el-input v-model="formData.bqrSorce" placeholder="请输入试卷得分" />
      </el-form-item>
      <el-form-item label="答题开始时间" prop="bqrStartTime">
        <el-date-picker
          v-model="formData.bqrStartTime"
          type="date"
          value-format="x"
          placeholder="选择答题开始时间"
        />
      </el-form-item>
      <el-form-item label="答题结束时间" prop="bqrEndTime">
        <el-date-picker
          v-model="formData.bqrEndTime"
          type="date"
          value-format="x"
          placeholder="选择答题结束时间"
        />
      </el-form-item>
      <el-form-item label="答题耗时" prop="bqrQuestTime">
        <el-date-picker
          v-model="formData.bqrQuestTime"
          type="date"
          value-format="x"
          placeholder="选择答题耗时"
        />
      </el-form-item>
    </el-form>
    <template #footer>
      <el-button @click="submitForm" type="primary" :disabled="formLoading">确 定</el-button>
      <el-button @click="dialogVisible = false">取 消</el-button>
    </template>
  </Dialog>
</template>
<script setup lang="ts">
import { getStrDictOptions, DICT_TYPE } from '@/utils/dict'
import { QuestionnaireResultApi, QuestionnaireResultVO } from '@/api/bjdxResult/questionnaireresult'

/** 北京大学-问卷结果 表单 */
defineOptions({ name: 'QuestionnaireResultForm' })

const { t } = useI18n() // 国际化
const message = useMessage() // 消息弹窗

const dialogVisible = ref(false) // 弹窗的是否展示
const dialogTitle = ref('') // 弹窗的标题
const formLoading = ref(false) // 表单的加载中：1）修改时的数据加载；2）提交的按钮禁用
const formType = ref('') // 表单的类型：create - 新增；update - 修改
const formData = ref({
  id: undefined,
  bqrUserId: undefined,
  bqrQuestionnaireId: undefined,
  bqrStatus: undefined,
  bqrSorce: undefined,
  bqrStartTime: undefined,
  bqrEndTime: undefined,
  bqrQuestTime: undefined,
  tenantId: undefined,
})
const formRules = reactive({
})
const formRef = ref() // 表单 Ref

/** 打开弹窗 */
const open = async (type: string, id?: number) => {
  dialogVisible.value = true
  dialogTitle.value = t('action.' + type)
  formType.value = type
  resetForm()
  // 修改时，设置数据
  if (id) {
    formLoading.value = true
    try {
      formData.value = await QuestionnaireResultApi.getQuestionnaireResult(id)
    } finally {
      formLoading.value = false
    }
  }
}
defineExpose({ open }) // 提供 open 方法，用于打开弹窗

/** 提交表单 */
const emit = defineEmits(['success']) // 定义 success 事件，用于操作成功后的回调
const submitForm = async () => {
  // 校验表单
  await formRef.value.validate()
  // 提交请求
  formLoading.value = true
  try {
    const data = formData.value as unknown as QuestionnaireResultVO
    if (formType.value === 'create') {
      await QuestionnaireResultApi.createQuestionnaireResult(data)
      message.success(t('common.createSuccess'))
    } else {
      await QuestionnaireResultApi.updateQuestionnaireResult(data)
      message.success(t('common.updateSuccess'))
    }
    dialogVisible.value = false
    // 发送操作成功的事件
    emit('success')
  } finally {
    formLoading.value = false
  }
}

/** 重置表单 */
const resetForm = () => {
  formData.value = {
    id: undefined,
    bqrUserId: undefined,
    bqrQuestionnaireId: undefined,
    bqrStatus: undefined,
    bqrSorce: undefined,
    bqrStartTime: undefined,
    bqrEndTime: undefined,
    bqrQuestTime: undefined,
    tenantId: undefined,
  }
  formRef.value?.resetFields()
}
</script>
